#include <iostream>
#include <cstring>
using namespace std;

int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a < b ? b : a;
}

int mincycle(int* arr, int n)
{
	int* p = new int[n];
	p[0] = 0;
	for (int i = 1; i < n; i++)
	{
		int k = p[i - 1];
		while (k > 0 && arr[i] != arr[k]) k = p[k - 1];
		k += (arr[i] == arr[k]);
		p[i] = k;
	}
	return n - p[n - 1];
	delete[] p;
}

int main()
{
	int n, m;
	cin >> n >> m;
	int* a = new int[n], *b = new int[m];
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < m; i++)
		cin >> b[i];
	if (m > n)
		swap(n, m), swap(a, b);
	{
		int c = mincycle(a, n);
		n = min(n, c + m - 1);
	}
	int* sumbuf = new int[m];
	int* even = new int[m], *odd = new int[m];
	int res = 0;
	for (int s = n - m; s >= 0; s--)
	{
		for (int j = 0; j < m; j++)
			sumbuf[j] = b[j] + a[s + j];
		int jl = 0, jr = 0;
		memset(odd, 0, m * sizeof(int)); memset(even, 0, m * sizeof(int));
		for (int i = 0; i < m; i++)
		{
			int ek, ok;
			if (i < jr)
			{
				ek = min(even[jl + jr - i], jr - i);
				ok = min(odd[jl + jr - i - 1], jr - i - 1) + 1;
			}
			else
				ek = 0, ok = 1;
			while (i + ek < m && i - ek > 0 && sumbuf[i + ek] == sumbuf[i - ek - 1]) ek++;
			while (i + ok < m && i - ok >= 0 && sumbuf[i + ok] == sumbuf[i - ok]) ok++;
			ok--;
			even[i] = ek; odd[i] = ok;
			res = max(res, max(ok * 2 + 1, ek * 2));
			if (jr < i + ek)
				jr = i + ek, jl = i - ek - 1;
			if (jr < i + ok + 1)
				jr = i + ok + 1, jl = i - ok;
		}
	}
	cout << res;
}