#include <iostream>
#include <cstring>
using namespace std;

int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a < b ? b : a;
}

int mincycle(int* arr, int n)
{
	int* p = new int[n];
	p[0] = 0;
	for (int i = 1; i < n; i++)
	{
		int k = p[i - 1];
		while (k > 0 && arr[i] != arr[k]) k = p[k - 1];
		k += (arr[i] == arr[k]);
		p[i] = k;
	}
	return n - p[n - 1];
	delete[] p;
}

int manaker(int n, int* s, int* even, int* odd, int& maxeven, int& maxodd)
{
	maxeven = maxodd = 0;
	int res = 0;
	int jl = 0, jr = 0;
	memset(odd, 0, n * sizeof(int)); memset(even, 0, n * sizeof(int));
	for (int i = 0; i < n; i++)
	{
		int ek, ok;
		if (i < jr)
		{
			ek = min(even[jl + jr - i], jr - i);
			ok = min(odd[jl + jr - i - 1], jr - i - 1) + 1;
		}
		else
			ek = 0, ok = 1;
		while (i + ek < n && i - ek > 0 && s[i + ek] == s[i - ek - 1]) ek++;
		while (i + ok < n && i - ok >= 0 && s[i + ok] == s[i - ok]) ok++;
		ok--;
		even[i] = ek; odd[i] = ok;
		maxeven = max(maxeven, ek * 2);
		maxodd = max(maxodd, ok * 2 + 1);
		res = max(res, max(maxodd, maxeven));
		if (jr < i + ek)
			jr = i + ek, jl = i - ek;
		if (jr < i + ok + 1)
			jr = i + ok + 1, jl = i - ok;
	}
	return res;
}

bool checkequal(int* arr, int n)
{
	for (int i = 1; i < n; i++)
		if (arr[i] != arr[i - 1])
			return false;
	return true;
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	int* a = new int[n], *b = new int[m];
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < m; i++)
		cin >> b[i];
	if (m > n)
		swap(n, m), swap(a, b);
	
	int amincycle = mincycle(a, n);
	
	if (amincycle == 1)
	{
		int d1, d2;
		cout << manaker(m, b, new int[m], new int[m], d1, d2);
		return 0;
	}
	if (checkequal(b, m))
	{
		int maxeven, maxodd;
		manaker(n, a, new int[n], new int[n], maxeven, maxodd);
		cout << max(min(m, maxeven) - (m & 1), min(m, maxodd) - !(m & 1));
		return 0;
	}
	n = min(n, amincycle + m - 1);
	
	int* even = new int[m], *odd = new int[m];
	int* sumbuf = new int[m];
	int res = 0;
	for (int s = n - m; s >= 0; s--)
	{
		for (int j = 0; j < m; j++)
			sumbuf[j] = b[j] + a[s + j];
		int d1, d2;
		res = max(manaker(m, sumbuf, even, odd, d1, d2), res);
	}
	cout << res;
}