#include <iostream>
#include <set>
using namespace std;

template<class T>
constexpr T max(T a, T b)
{
	return a > b ? a : b;
}

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, k; cin >> n >> k;
	int* a = new int[n];
	for (int i = 0; i < n; i++)
		cin >> a[i];
	int64_t* sums = new int64_t[n];
	sums[0] = a[0];
	for (int i = 1; i < n; i++)
		sums[i] = a[i] + sums[i - 1];
	int64_t maxans = 0x8000000000000000;
	multiset<int>* maxs = new multiset<int>[n];
	int64_t* sumsmax = new int64_t[n]{};
	for (int len = 1; len <= n; len++)
	{
		for (int i = 0; i <= n - len; i++)
		{
			int cur = a[i + len - 1];
			maxs[i].insert(cur);
			sumsmax[i] += cur;
			if (maxs[i].size() > k)
			{
				auto b = maxs[i].begin();
				sumsmax[i] -= *b;
				maxs[i].erase(*b);
			}
			maxans = max(maxans, sums[i + len - 1] - (i > 0 ? sums[i - 1] : 0) - sumsmax[i]);
		}
	}
	cout << maxans;
}